/**
 * From <a href="http://stackoverflow.com/questions/14338078/equivalent-of-deprecated-jquery-toggle-event">stackoverflow post</a>.
 * Add toggle method for jquery 2.0.
 * @module toggler
 * 
 * @requires <a href='http://blog.jquery.com/2011/09/12/jquery-1-6-4-released/'>jQuery 1.6.4+</a>
 * @dependency <script language="JavaScript" type="text/javascript" src="../biojs/dependencies/jquery/jquery-1.4.2.min.js"></script>
 * 
 * @example
 * 		$(selector).toggler(function1({...}), function2({...}));
 */
(function( $ ){
"use strict";	
  /**
   * Add toggle method for jquery 2.0
   * @class toggler
   * @constructor
   * @param {Object} fn
   * @param {Object} fn2
   * @requires <a href='http://blog.jquery.com/2011/09/12/jquery-1-6-4-released/'>jQuery 1.6.4</a>
   */	
  $.fn.toggler = function( fn, fn2 ) {
    var args = arguments,guid = fn.guid || $.guid++,i=0,
    toggler = function( event ) {
      var lastToggle = ( $._data( this, "lastToggle" + fn.guid ) || 0 ) % i;
      $._data( this, "lastToggle" + fn.guid, lastToggle + 1 );
      event.preventDefault();
      return args[ lastToggle ].apply( this, arguments ) || false;
    };
    toggler.guid = guid;
    while ( i < args.length ) {
      args[ i++ ].guid = guid;
    }
    return this.click( toggler );
  };
})( jQuery );