#!/bin/bash

echo "Building start..."
cd ./GSV/
zip -r app.nw ./*
cd ..

if [[ "$OSTYPE" == "linux" ]];
then
    nss_version=$(nss-config --version)
    nss_int=$(echo $nss_version | sed "s/\.//g")
	dir_nodeWebkit="./nodeWebkit"
	if [ -f "node-webkit-v0.7.5-linux-x64.tar.gz" ] || [ -f "node-webkit-v0.9.2-linux-x64.tar.gz" ]
	then 
			echo "node-webkit-v0.7.5-linux-x64.tar.gz or node-webkit-v0.9.2-linux-x64.tar.gz already exist"
	else 
			if [ "$(uname -m)" == "x86_64" ]
			then
				if [ $nss_int -lt 3143 ]
				then 
					targzNW="node-webkit-v0.7.5-linux-x64.tar.gz"
					echo "Download node-webkit 7.5 for linux 64bits..."		
					wget "https://s3.amazonaws.com/node-webkit/v0.7.5/$targzNW"
				else
					targzNW="node-webkit-v0.9.2-linux-x64.tar.gz"
					echo "Download node-webkit 9.2 for linux 64bits..."		
					wget "http://dl.node-webkit.org/v0.9.2/$targzNW"
				fi	
			elif [ "$(uname -m)" == "i686" ]
			then
				targzNW="node-webkit-v0.9.2-linux-ia32.tar.gz"
				echo "Download node-webkit for linux 32bits..."
				wget "http://dl.node-webkit.org/v0.9.2/$targzNW"
			fi 
			
			if [ -d "$dir_nodeWebkit" ]
			then 
				echo "$dir_nodeWebkit already exist"
			elif [ -f "$targzNW" ];
				then
					echo "Decompress node-webkit..."
					tar -zxvf $targzNW
					mv ./node-webkit-*-linux-*/ nodeWebkit/
				else
					echo "$targzNW can't be downloaded"
					
			fi
			
	fi
	cd ./nodeWebkit/
	mv ../GSV/app.nw ./
	cat nw app.nw > GSVDesktop
	cd ..

    if [ -d "./GSVDesktop.d/" ];
        then
            echo "Purge old build"
            rm -r ./GSVDesktop.d/
    fi
    
    echo "..."
    #rm ./nodeWebkit/package.nw
    mkdir GSVDesktop.d

    if [ -f "./nodeWebkit/GSVDesktop" ];
        then
            mv ./nodeWebkit/GSVDesktop ./GSVDesktop.d/
            chmod +x ./GSVDesktop.d/GSVDesktop*
            cp ./nodeWebkit/nw.pak ./GSVDesktop.d/
            cp ./nodeWebkit/libffmpegsumo.so ./GSVDesktop.d/
    fi

elif [[ "$OSTYPE" == "darwin"* ]];
then
	zipNW="node-webkit-v0.9.2-osx-ia32.zip"
	dir_nodeWebkit="./nodeWebkit"
	if [ -f "$zipNW" ];
	then 
			echo "$zipNW already exist"
            cp -R ./GSV/app.nw ./nodeWebkit/node-webkit.app/Contents/Resources/
            cp -R ./nodeWebkit/node-webkit.app ./nodeWebkit/GSVDesktop.app
	else
			echo "Download node-webkit for MacOS X..."

            curl "http://dl.node-webkit.org/v0.9.2/$zipNW" -o "node-webkit-v0.9.2-osx-ia32.zip"
            if [ -d "$dir_nodeWebkit" ]
			then 
				echo "$dir_nodeWebkit already exist"
			elif [ -f "$zipNW" ];
				then
					echo "Decompress node-webkit..."
					unzip node-webkit-v0.9.2-osx-ia32 -d nodeWebkit/
					cp -R ./GSV/app.nw ./nodeWebkit/node-webkit.app/Contents/Resources/
                    cp -R ./nodeWebkit/node-webkit.app ./nodeWebkit/GSVDesktop.app
				else
					echo "$zipNW can't be downloaded"
				
								
			fi
	fi

    if [ -d "./GSVDesktop.d/" ];
        then
            echo "Purge old build"
            rm -r ./GSVDesktop.d/
    fi

echo "..."

mkdir GSVDesktop.d

    if [ -d "./nodeWebkit/GSVDesktop.app" ];
        then
        mv ./nodeWebkit/GSVDesktop.app ./GSVDesktop.d/
        chmod +x ./GSVDesktop.d/GSVDesktop*
    fi
fi

echo "End"
